/*
 * Copyright (c) 2003 Linuxant inc.
 *
 * NOTE: The use and distribution of this software is governed by the terms in
 * the file LICENSE, which is included in the package. You must read this and
 * agree to these terms before using or distributing this software.
 *
 */

#define OS_NOSTRINGREDEFS

#include "oscompat.h"
#include "osservices.h"

PVOID OsMemSet(PVOID pBuf, UINT8 c, UINT32 Count)
{
    return memset(pBuf, c, Count);
}

PVOID OsMemMove(PVOID pDest, PVOID pSrc, UINT32 Count)
{
    return memmove(pDest, pSrc, Count);
}

PVOID OsMemCpy(PVOID pDest, PVOID pSrc, UINT32 Count)
{
    return memcpy(pDest, pSrc, Count);
}

int OsMemCmp(PVOID pBuff1, PVOID pBuff2, UINT32 Count)
{
    return memcmp(pBuff1, pBuff2, Count);
}

PVOID OsStrCpy(LPSTR szDest, LPCSTR szSrc)
{
    return strcpy(szDest, szSrc);
}

PVOID OsStrnCpy(LPSTR szDest, LPCSTR szSrc, int MaxSize)
{
    return strncpy(szDest, szSrc, MaxSize);
}

LPSTR OsStrCat(LPSTR szDest, LPCSTR szSrc)
{
    return strcat(szDest, szSrc);
}

LPSTR OsStrnCat(LPSTR szDest, LPCSTR szSrc, int MaxSize)
{
    return strncat(szDest, szSrc, MaxSize);
}

int OsStrCmp(LPCSTR szStr1, LPCSTR szStr2)
{
    return strcmp(szStr1, szStr2);
}

int OsStrnCmp(LPCSTR szStr1, LPCSTR szStr2, UINT32 Count)
{
    return strncmp(szStr1, szStr2, Count);
}

int OsStrLen(const char * string)
{
    return strlen(string);
}

int OsToupper(int ch)
{
    return (ch >='a' && ch <= 'z') ? ch-'a'+'A' : ch;
}

int OsTolower(int ch)
{
    return (ch >='A' && ch <= 'Z') ? ch-'A'+'a' : ch;
}

int OsIsDigit(int ch)
{
    return (ch >='0' && ch <='9');
}

int OsVSprintf(LPSTR buffer, LPCSTR format, va_list ap)
{
    return vsprintf(buffer, format, ap);
}

int OsSprintf(LPSTR buffer, LPCSTR format, ...)
{
    va_list   args;
    int    RetVal;

    va_start (args , format);
    RetVal = vsprintf(buffer,format,args);
    va_end (args);
    return RetVal;
}

int OsAtoi(LPCSTR szStr)
{
    const char *temp_string = szStr;
    int temp = 0;
    while ( *temp_string ) {
	temp <<= 4;
	if ( OsIsDigit(*temp_string)) {
	    temp += (*temp_string - '0');
	}
	if (*temp_string <= 'f' && *temp_string >= 'a') {
	    temp += ((*temp_string - 'a')+10);
	}
	if (*temp_string <= 'F' && *temp_string >= 'A') {
	    temp += ((*temp_string - 'A')+10);
	}
	temp_string++;  
    }
    return (temp);
}

